/*
 * Copyright 1991, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include "is_types.h"
#include "isam.h"

#ifndef lint
static	char	sccsid[] = "@(#)is_dict.c	1.3	08:11:24	1/27/92";
#endif

#define	OFF_FILENO	0
#define	OFF_FIELDNO	(sizeof (int) + OFF_FILENO)
#define	OFF_FIELDTYPE	(sizeof (int) + OFF_FIELDNO)
#define	OFF_FIELDSIZE	(sizeof (int) + OFF_FIELDTYPE)
#define	OFF_FIELDFILE	(sizeof (int) + OFF_FIELDSIZE)
#define	OFF_FIELDNAME	(MAXFILENAME + OFF_FIELDFILE)
#define	OFF_FIELDKEYS	(MAXFIELDNAME + OFF_FIELDNAME)

field_t	dict_fields[] = {
/* 0 */	{ T_INT,	sizeof (int),	OFF_FILENO, ".fileno" },
/* 1 */	{ T_INT, 	sizeof (int),	OFF_FIELDNO, ".fieldno" },
/* 2 */	{ T_INT,	sizeof (int),	OFF_FIELDTYPE, ".fieldtype" },
/* 3 */	{ T_INT,	sizeof (int),	OFF_FIELDSIZE, ".fieldsize" },
/* 4 */	{ T_CHAR,	MAXFILENAME,	OFF_FIELDFILE, ".fieldfile" },
/* 5 */	{ T_CHAR,	MAXFIELDNAME,	OFF_FIELDNAME, ".fieldname" },
/* 6 */	{ T_SHORT,	sizeof (short) * MAXSORTFIELDS, OFF_FIELDKEYS, ".fieldkeys" },
/* 7 */	{ T_INDEX,	-1,		1, ".filekey" },
/* 8 */	{ T_INDEX,	2,		2, ".filefieldkey" },
/* 9 */	{ T_INDEX,	-1,		3, ".filenmkey" },
/* 10 */ { T_INDEX,	-1,		4, ".fieldnmkey" },
/* 11 */ { T_INDEX,	2,		5, ".fieldfilenmkey" }
};

schema_t dict_schema = {
	11, dict_fields
};

/*
 * The data dictionary indices are:
 *
 *	1 - File number
 *	2 - File and field numbers (unique)
 *	3 - File name
 *	4 - Field name
 *	5 - File and field names (unique)
 */

sort_key_t dict_keys[] = {
/* 0 */	{ 0,	0,	0, 0, { 0 } },
/* 1 */	{ 7,	2,	sizeof (int) + sizeof (off_t), 0, { 0 } },
/* 2 */	{ 8,	2,	2 * sizeof (int), 1, { 0, 1 } },
/* 3 */	{ 9,	2, 	MAXFILENAME + sizeof (off_t), 0, { 4 } },
/* 4 */	{ 10,	2,	MAXFIELDNAME + sizeof (off_t), 0, { 5 } },
/* 5 */	{ 11,	2,	MAXFIELDNAME + MAXFILENAME, 1, { 4, 5 } }
};

is_index_t dict_index = {
	5, dict_keys
};
