#!/bin/sh
#
# Test 5
#	Check for deleting database files
#
#	@(#)test_05.sh	1.3	12:32:13	2/21/92
#
rm -f test[0123].dat test[0123].idx test.out
set -e
RC=1

trap 'rm -f test.out test.sch test_05.o test_05 test[0123].dat test[0123].idx ; exit $RC' 0 1 2 15

#
# create the test C program
#
cc -o test_05 $CCFLAGS test_05.c libidbm.a $LDFLAGS

DBPATH=. ; export DBPATH

#
# create a schema containing 3 files
#

cat > test.sch << EOF
database test0

file test1

field field11 type int
field field12 type int

file test2

field field21 type short
field field22 type short

file test3

field field31 type double
field field32 type double

end
EOF

./dbschema test.sch

#
# get the schema for the new database, and make certain it is correct
#

./dbshow test0 > test.out
cmp - test.out << EOF
database test0

file test1

field	field11	type	int
field	field12	type	int

file test2

field	field21	type	short
field	field22	type	short

file test3

field	field31	type	double
field	field32	type	double

end
EOF

#
# now we delete file test2
#

./test_05 test0 test2
./dbshow test0 > test.out
cmp - test.out << EOF
database test0

file test1

field	field11	type	int
field	field12	type	int

file test3

field	field31	type	double
field	field32	type	double

end
EOF

#
# re-create the test2 file
#
cat > test.sch << EOF
database test0

file test2

field field21 type short
field field22 type short

end
EOF
./dbschema test.sch
./dbshow test0 > test.out
cmp - test.out << EOF
database test0

file test1

field	field11	type	int
field	field12	type	int

file test2

field	field21	type	short
field	field22	type	short

file test3

field	field31	type	double
field	field32	type	double

end
EOF

#
# everything is OK, exit
#
RC=0
